export HOMEBREW_NO_ANALYTICS=1

# set PATH so it includes user's private bin if it exists
if [ -d "$HOME/bin" ] ; then
  PATH="$HOME/bin:$PATH"
fi

alias app_user='echo "You are already in the app user shell"'
alias aliases="cat ~/.app_bash_aliases | \grep alias | sed -e 's/alias //g' | sort | \egrep '^[^=]+' --color=auto"

alias services_status="SYSTEMD_COLORS=1 systemctl list-units --user --type=service"
alias service_states="services_status"
alias status_all="services_status"
alias services="services_status"
alias container_status="services_status"

alias service_dir="cd {{ service_dir }}"
alias cdservice_dir="service_dir"
alias volumes_dir="cd {{ volume_root_dir }}"
alias cdvolumes_dir="volumes_dir"

alias global_podman_logs="podman logs --latest --names --timestamps --since=10m --tail={{ tail_default_lines }} --names --color"
alias last_podman_logs="podman pod logs --timestamps --tail={{ tail_default_lines }} {{ default_pod_name }}"
alias podman_logs_last="last_podman_logs"
alias last_container_logs="last_podman_logs"
alias latest_container_logs="last_podman_logs"
function podman_log() {
  podman logs --follow --tail={{ tail_default_lines }} --timestamps "$@" | bat --paging=never -l log
}
alias podman_ports="podman port -l"
alias podman_app_ports='podman container ls --format "table {% raw %}{{.ID}}\t{{.Names}}\t{{.Ports}}{% endraw %}" -a'

{% for name, service_name in service_aliases.items() %}
# === BEGIN Aliases for '{{name}}'
if [[ -f "{{ service_dir }}/{{ service_name }}.service" ]]; then
  function {{ name }}_log() {
    podman logs --follow --tail={{ tail_default_lines }} --timestamps {{ name }} "$@" | bat --paging=never -l log
  }
  alias {{ name }}_exec="podman exec {{ name }}"
  alias {{ name }}_sh="podman exec -it {{ name }} sh"
  alias {{ name }}_ls="podman exec -it {{ name }} ls --color=always"
  alias {{ name }}_bash="podman exec -it {{ name }} bash"
  alias {{ name }}_status="systemctl --user status {{ service_name }}.service"
  alias {{ name }}_service_status="{{ name }}_status"
  alias {{ name }}_service_log="journalctl --user -xeu {{ service_name }}.service"
  alias journalctl_{{ name }}="{{ name }}_service_log"
  alias systemctl_{{ name }}_status="{{ name }}_status"
  alias {{ name }}_restart="systemctl restart {{ service_name }}.service --user"
  alias {{ name }}_start="systemctl start {{ service_name }}.service --user"
  alias {{ name }}_stop="systemctl stop {{ service_name }}.service --user"
  alias {{ name }}_top="podman top {{ name }} user args pcpu etime pid ppid tty"
  alias restart_{{ name }}="{{ name }}_restart"
  alias start_{{ name }}="{{ name }}_start"
  alias stop_{{ name }}="{{ name }}_stop"
  alias status_{{ name }}="{{ name }}_status"
  alias {{ name }}_create_command='podman inspect -f {% raw %}"{{ join .Config.CreateCommand \" \" }}"{% endraw %} {{ name }}'
  alias {{ name }}_exit_command='podman inspect -f "{% raw %}{{.ExitCommand}}{% endraw %}" {{ name }}'
  alias {{ name }}_image="podman inspect -f '{% raw %}{{.ImageName}}{% endraw %}' {{ name }}"
  function cd{{name}}() {
    DIR="{{ volume_root_dir }}/{{ name }}"
    if [ -d "$DIR" ];
    then
        cd "${DIR}"
    else
    	echo "I don't know where to find the {{ name }} volume."
    fi
  }
  function {{ name }}_rm() {
    echo -n "\n\n  🛑 Are you sure that you want to delete {{ name }} and all of its dependencies? [y/N] "
    read REPLY
    echo "\n"

    if [[ $REPLY =~ ^[Yy]$ ]]
    then
      systemctl stop {{ service_name }}.service --user
      podman rm {{ name }} --depend --force
      echo "\n\t🗑️  {{ name }} and all of its dependencies have been deleted.\n\n"
    fi
  }

  alias {{ name }}_remove="{{ name }}_rm"
  alias {{ name }}_delete="{{ name }}_rm"
  function {{ name }}_user() {
    podman image inspect --format {% raw %}{{.User}}{% endraw %} "$({{ name }}_image)"
  }
  function podman_inspect() {
    podman inspect $1 | bat --language JSON
  }
  alias {{ name }}_inspect='podman inspect {{ name }} | bat --language JSON'
  alias {{ name }}_env='podman inspect --format "{% raw %}{{range \$index, \$value := .Config.Env}}{{\$value}}{{println}}{{end}}{% endraw %}" {{ name }} | sort | bat --language sh --paging=never'
  alias {{ name }}_volumes="podman inspect --format='{% raw %}{{range .Mounts}}{{print .Source}}\t=> {{println .Destination}}{{end}}{% endraw %}' {{ name }}"
  alias {{ name }}_mounts="{{ name }}_volumes"
  alias {{ name }}_ports='podman inspect --format "{% raw %}{{.NetworkSettings.Ports}}{% endraw %}" {{ name }}'
  alias {{ name }}_ip='podman inspect --format "{% raw %}{{.NetworkSettings.IPAddress}}{% endraw %}" {{ name }}'
  function {{ name }}_single_run() {
    podman run $({{ name }}_image) --rm
  }
  function {{ name }}_uid_gid() {
    user=$(echo $({{ name }}_user) | sed "s/:.*//")
    [[ -z "$user" ]] && { echo "User for {{ name }} container seem to be empty $({{ name }}_user)" ; return 1; }
    tmpdir=$(mktemp -d)
    container_id=$(podman create $({{ name }}_image))
    podman cp $container_id:/etc/passwd $tmpdir
    echo "Username is '${user}'. UID and GID will be grepped from ${tmpdir}/passwd"
    command grep -I --color $user $tmpdir/passwd
    podman rm $container_id > /dev/null
  }
fi
# ===   END Aliases for '{{name}}'
{% endfor %}

if [[ -f "{{ service_dir }}/{{ container_service_prefix }}-penpot_backend.service" ]]; then
  alias penpot_rm="penpot_frontend_rm;penpot_backend_rm;penpot_exporter_rm;"
fi
if [[ -f "{{ service_dir }}/gocryptfs.service" ]]; then
  alias gocryptfs_log="gocryptfs_service_log"
fi

# Postgres aliases

{% if postgres_admin_user is defined -%}
alias psql="podman exec -it postgres psql -U {{ postgres_admin_user }}"
alias postgres="psql"
alias postgres_databases="podman exec -it postgres psql -U {{ postgres_admin_user }} -l"
alias postgres_users="podman exec -it postgres psql -U {{ postgres_admin_user }} -c '\du'"
function createdb() {
  podman exec -it postgres psql -U {{ postgres_admin_user }} -tc "SELECT 1 FROM pg_database WHERE datname = '$1'" | grep -q 1 | psql -U postgres -c "CREATE DATABASE $1";
}
{%- endif %}

# Other database aliases

{% if mariadb_admin_user is defined -%}
alias mariadb="podman exec -it mariadb mysql -u {{ mariadb_admin_user }} -p'{{ mariadb_admin_password }}'"
alias mysql="mariadb"
{%- endif %}
alias mongodb="podman exec -it mongodb mongo"

alias redis-cli="podman exec -it redis redis-cli"
alias redis_databases="redis-cli INFO keyspace"

{% if clickhouse_admin_user is defined -%}
alias clickhouse="podman exec -it clickhouse clickhouse-client --user {{ clickhouse_admin_user }} --password {{ clickhouse_admin_password }}"
alias clickhouse-client="clickhouse"
{%- endif %}

{% if lldap_db_name is defined -%}
alias lldap_db="psql {{ lldap_db_name }}"
alias ldap_check="ldapsearch -x -LLL -h localhost:{{ lldap_port }} -D user -w password -b'{{ ldap_standard_domain_component }}' -s sub '(objectClass=user)' givenName"
{%- endif %}

if [[ -f "{{ service_dir }}/{{ container_service_prefix }}-mailserver.service" ]]; then
  # Mailserver aliases
  alias mailserver_setup="mailserver_exec setup"
  alias mailserver_log_official="mailserver_exec setup debug show-mail-logs | bat --language log"
  alias mailserver_email="mailserver_exec setup email"
  function email() {
    if [ -z $1 ]; then
      mailserver_exec setup | grep "setup email" -B1 | sed -En "s/^.+setup email/email/p"
    elif [[ "${1}" == "list" ]]; then
      mailserver_exec setup email list | sed -E "/^\s*$/d"
    else
      mailserver_exec setup email "$@"
    fi
  }
  function email_alias() {
    if [ -z $1 ]; then
      mailserver_exec setup | grep "setup alias" -B1 | sed -En "s/^.+setup alias/email_alias/p"
    elif [[ "${1}" == "list" ]]; then
      mailserver_exec setup alias list | sed -E "/^\s*$/d"
    else
      mailserver_exec setup alias "$@"
    fi
  }
  alias mailserver_aliases="email_alias list"
  alias mailserver_accounts="email list"
  alias mailserver_version="mailserver_exec cat /VERSION"
  alias mailserver_fail2ban="mailserver_exec setup fail2ban"
  alias dovecot_config="mailserver_setup debug login doveconf" | bat --language nginx

  # https://github.com/docker-mailserver/docker-mailserver#dns---dkim
  {% if mailserver_use_rspamd %}
  function rspamd_log() {
    tail -f {{ volume_root_dir }}/mailserver/supervisor_logs/rspamd.log -n {{ tail_default_lines }} | bat --paging=never --language log
  }
  function dkim_log(){
    tail -f {{ volume_root_dir }}/mailserver/supervisor_logs/rspamd.log -n {{ tail_default_lines }} | rg -v "(SPAM_FLAG|SUBJECT_ENDS_EXCLAIM|PREVIOUSLY_DELIVERED|WHITELIST_DMARC|DBL_SPAM|FORGED_RECIPIENTS|RCPT_COUNT_ONE)" | rg dkim
  }
  function cddkim() {
    cdmailserver && cd config/rspamd_dkim_keys;
  }
  {% else %}
  function cddkim() {
    cdmailserver && cd config/opendkim;
  }
  function dkim() {
    args="$@"
    mailserver_exec setup config dkim ${args:='help'}
  }
  alias mailserver_dkim=dkim
  function dkim_generate_keys() {
    {% for domain in mailserver_domains %}
    dkim_{{ domain }}_generate_key
    {% endfor %}
  }
  alias mailserver_dkim_generate_keys=dkim_generate_keys
  alias dkim_testkeys="mailserver_exec opendkim-testkey"
  alias mailserver_opendkim_testkey="mailserver_exec opendkim-testkey"
  alias mailserver_dkim_testkey="mailserver_exec opendkim-testkey"
  {% endif %}{# mailserver_use_rspamd #}

  {% for domain in mailserver_domains %}
    function dkim_{{ domain }}_public_key() {
      mailserver_exec cat {{ mailserver_internal_rspamd_dkim_key_dir }}/{{ domain }}/keys/{{ mailserver_rspamd_dkim_selector }}.txt
    }
    alias alias mailserver_dkim_{{ domain }}_public_key=dkim_{{ domain }}_public_key
    function dkim_{{ domain }}_current_txt_entry() {
      dig TXT "mail._domainkey.{{ domain }}" +short
    }
    alias alias mailserver_dkim_{{ domain }}_current_txt_entry=dkim_{{ domain }}_current_txt_entry

    {% if mailserver_use_rspamd %}
    function dkim_{{ domain }}_generate_key() {
      mailserver_exec rspamadm dkim_keygen --selector {{ mailserver_rspamd_dkim_selector }} \
                                           --bits {{ dkim_key_size }} \
                                           --domain {{ domain }} \
                                           --privkey {{ mailserver_internal_rspamd_dkim_key_dir }}/{{ domain }}/keys/{{ mailserver_rspamd_dkim_selector }}.private > {{ mailserver_external_rspamd_dkim_key_dir }}/{{ domain }}/keys/{{ mailserver_rspamd_dkim_selector }}.txt
    }
    {% endif %}{# if mailserver_use_rspamd #}
  {% endfor %}{# domain in mailserver_domains #}
  alias postgrey_entries="rg 'Delayed by Postgrey' {{ mailserver_data_path }}/logs/*.log | rg -v '(fubella|udalix|dropboxalx|netcup|kadamebklz|xztrsfth|microalex|microalex|bloginhaber)' | sed 's%.*RCPT from %%' | sed 's%>:.*%%' | uniq"
  alias mailserver_postgrey_entries="postgrey_entries"
fi

alias browse="podman run -it fathyb/carbonyl"
alias browser="browse"
alias www=browse
